/*
 * Created on 15/lug/06
 *
 */
package portachiavi;

/**
 * Controllore del portachiavi
 * 
 * @author andrea
 * 
 */
public interface IController {

	/**
	 * Aggiunge un elemento al portachiavi
	 * 
	 * @return true se l'elemento è stato aggiunto
	 */
	public boolean addEntry();

	/**
	 * 
	 * 
	 */
	public void autoLoadPortachiavi();

	/**
	 * 
	 * @return
	 */
	public boolean changePassword();

	/**
	 * Esce dal programma
	 * 
	 */
	public void exit();

	/**
	 * Salva i due file del portachiavi dentro un archivio zippato per
	 * facilitare il trasferimento del portachiavi.
	 * 
	 * @return true se tutto OK
	 */
	public boolean exportToArchive();

	/**
	 * 
	 * @return true se l'esportazione è andata bene.
	 */
	public boolean exportToTextFile();

	/**
	 * 
	 * @return true se tutto OK
	 */
	public boolean importFromArchive();

	/**
	 * Carica il portachiavi da disco rigido.
	 * 
	 * @return true se il portachiavi è stato caricato correttamente
	 */
	public boolean loadPortachiavi();

	/**
	 * Modifica un elemento del portafoglio
	 * 
	 * @return true se la modifica ha avuto successo
	 */
	public boolean modificaEntry();

	/**
	 * Rimouve un elemento dal portachiavi.
	 * 
	 * @return true se l'elemente è stato rimosso.
	 */
	public boolean removeEntry();

	/**
	 * Salva il portachiavi su disco rigido
	 * 
	 * @return true se il salvataggio è avvenuto correttamente.
	 */
	public boolean savePortachiavi();

	/**
	 * Cerca un elemento nel portachiavi.
	 * 
	 * @return true se l'elemento è presente
	 */
	public boolean searchEntry();

	/**
	 * Apre un pannello in cui inserire la nuova password per il portachiavi e
	 * la salva.
	 * 
	 */
	public void setFirstPassword();

	/**
	 * Apre un pannello in cui inserire la nuova password per il portachiavi e
	 * la salva.
	 * 
	 */
	public void setPassword();

}