/*
 * Created on 13/lug/06
 *
 */
package portachiavi;

import java.io.Serializable;

public class LoginData implements ILoginData, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String password;
	private long timestamp;
	private String user;

	/**
	 * 
	 * @param user
	 * @param password
	 */
	public LoginData(String user, String password) {
		this.user = user;
		this.password = password;
		updateTimestamp();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see portachiavi.IAuth#getPassword()
	 */
	public String getPassword() {
		return password;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see portachiavi.IAuth#getTimestamp()
	 */
	public long getTimestamp() {
		return timestamp;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see portachiavi.IAuth#getUser()
	 */
	public String getUser() {
		return user;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see portachiavi.IAuth#setPassword(java.lang.String)
	 */
	public void setPassword(String password) {
		this.password = password;
		updateTimestamp();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see portachiavi.IAuth#setUser(java.lang.String)
	 */
	public void setUser(String user) {
		this.user = user;
		updateTimestamp();
	}

	private void updateTimestamp() {
		timestamp = System.currentTimeMillis();
	}
}
