/*
 * Created on 14/lug/06
 *
 */
package portachiavi.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Toolkit;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Locale;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class EntryDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private String date = "";
	private JTextField dateField = null;
	private String id = "";
	private JTextField idField = null;
	private JButton jButton = null;
	private JPanel jContentPane = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private String password = "";
	private JTextField passwordField = null;
	private JTextField userField = null;
	private String username = "";

	public EntryDialog() {
		super();
		initialize();
	}

	/**
	 * 
	 * @param id
	 *            vecchio ID
	 * @param username
	 *            vecchio username
	 * @param password
	 *            vecchia password
	 * @param timestamp
	 *            data ultima modifica
	 */
	public EntryDialog(String id, String username, String password,
			long timestamp) {
		super();
		this.id = id;
		this.username = username;
		this.password = password;
		Calendar calendar = Calendar.getInstance();
		calendar.setTimeInMillis(timestamp);
		DateFormat df = DateFormat.getDateTimeInstance(DateFormat.FULL,
				DateFormat.MEDIUM, Locale.ITALY);
		date = df.format(calendar.getTime());
		initialize();
	}

	private JTextField getDateField() {
		if (dateField == null) {
			dateField = new JTextField(date);
			dateField.setColumns(20);
			dateField.setEditable(false);
		}
		return dateField;
	}

	public String getId() {
		return id;
	}

	private JTextField getIdField() {
		if (idField == null) {
			idField = new JTextField(id);
			idField.setColumns(20);
		}
		return idField;
	}

	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("OK");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					id = getIdField().getText();
					username = getUserField().getText();
					password = getPasswordField().getText();
					setVisible(false);
				}
			});
		}
		return jButton;
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel1 = new JLabel("Identificatore: ");
			jLabel2 = new JLabel("Username: ");
			jLabel3 = new JLabel("Password: ");
			jLabel4 = new JLabel("Ultima modifica: ");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(getIdField(), new GridBagConstraints(1, 0, 1, 1,
					1.0, 0.0, GridBagConstraints.CENTER,
					GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(jLabel2, new GridBagConstraints(0, 1, 1, 1, 0.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(getUserField(), new GridBagConstraints(1, 1, 1, 1,
					1.0, 0.0, GridBagConstraints.CENTER,
					GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(getPasswordField(), new GridBagConstraints(1, 2,
					1, 1, 1.0, 0.0, GridBagConstraints.CENTER,
					GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(jLabel4, new GridBagConstraints(0, 3, 1, 1, 0.0,
					0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
					new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(getDateField(), new GridBagConstraints(1, 3, 1, 1,
					1.0, 0.0, GridBagConstraints.CENTER,
					GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			jContentPane.add(getJButton(), new GridBagConstraints(1, 4, 1, 1,
					0.0, 0.0, GridBagConstraints.CENTER,
					GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), 0, 0));
		}
		return jContentPane;
	}

	public String getPassword() {
		return password;
	}

	private JTextField getPasswordField() {
		if (passwordField == null) {
			passwordField = new JTextField(password);
			passwordField.setColumns(20);
		}
		return passwordField;
	}

	private JTextField getUserField() {
		if (userField == null) {
			userField = new JTextField(username);
			userField.setColumns(20);
		}
		return userField;
	}

	public String getUsername() {
		return username;
	}

	private void initialize() {
		setContentPane(getJContentPane());
		setModal(true);
		pack();
		setLocationRelativeTo(null);
		Image icon = Toolkit.getDefaultToolkit().getImage(
				getClass().getResource("/data/app.png"));
		setIconImage(icon);
	}

}
