/*
 * Created on 13/lug/06
 *
 */
package portachiavi.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.SwingConstants;

public class PasswordDialog extends JDialog implements KeyListener {

	private static final long serialVersionUID = 1L;
	private JButton jButton = null;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabelIcon = null;
	private JPanel jPanel = null;
	private JPasswordField jPasswordField1 = null;
	private char[] password;

	public PasswordDialog() {
		super();
		initialize();
	}

	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("OK");
			jButton.setHorizontalAlignment(SwingConstants.RIGHT);
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					password = getJPasswordField1().getPassword();
					setVisible(false);
					getJPasswordField1().setText("");
				}
			});
		}
		return jButton;
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.CENTER);
			jContentPane.add(getJLabelIcon(), BorderLayout.WEST);
		}
		return jContentPane;
	}

	private JLabel getJLabelIcon() {
		if (jLabelIcon == null) {
			jLabelIcon = new JLabel();
			jLabelIcon.setText("");
			jLabelIcon.setHorizontalTextPosition(SwingConstants.CENTER);
			jLabelIcon.setHorizontalAlignment(SwingConstants.CENTER);
			jLabelIcon.setPreferredSize(new Dimension(50, 50));
			jLabelIcon.setIcon(new ImageIcon(getClass().getResource(
					"/data/password.png")));
		}
		return jLabelIcon;
	}

	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("Inserisci la password: ");
			jLabel.setPreferredSize(new Dimension(139, 15));
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 3;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.gridx = 1;
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(getJPasswordField1(), gridBagConstraints2);
			jPanel.add(getJButton(), gridBagConstraints5);
			jPanel.add(jLabel, gridBagConstraints);
		}
		return jPanel;
	}

	private JPasswordField getJPasswordField1() {
		if (jPasswordField1 == null) {
			jPasswordField1 = new JPasswordField();
			jPasswordField1.setColumns(20);
			jPasswordField1.addKeyListener(this);
		}
		return jPasswordField1;
	}

	public char[] getPassword() {
		return password;
	}

	private void initialize() {
		setTitle("Log-in");
		setContentPane(getJContentPane());
		setModal(true);
		this.setSize(300, 100);
		setLocationRelativeTo(null);
		Image icon = Toolkit.getDefaultToolkit().getImage(
				getClass().getResource("/data/app.png"));
		setIconImage(icon);
	}

	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_ENTER) {
			password = getJPasswordField1().getPassword();
			setVisible(false);
			getJPasswordField1().setText("");
		}
	}

	public void keyReleased(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
	}

}
